#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "bits_macros.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
#define DC0_PORT PORTB
#define DC0_DDR DDRB
#define DC0_PIN 2
#define DC1_PORT PORTD
#define DC1_DDR DDRD
#define DC1_PIN 5

#define PWM_PORT PORTD
#define PWM_DDR DDRD
#define PWM_PIN PIND
#define PWM_IN 3

#define JP_PORT PORTB
#define JP_DDR DDRB
#define JP_PIN PINB
#define JP_IN 0

unsigned char non_revers;
unsigned int counter;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void reg_config(void)
{
   DC0_PORT = 0x00;
   DC1_PORT = 0x00;
   DC0_DDR |= (1 << DC0_PIN);
   DC1_DDR |= (1 << DC1_PIN);
   
   PWM_DDR &= ~(1 << PWM_PIN);
   PWM_PORT &= ~(1 << PWM_PIN);
   
   JP_DDR &= ~(1 << JP_IN);
   JP_PORT |= (1 << JP_IN);
   
   TCCR0A = 0xFF;
   TCCR0B |= ((1 << CS01)|(1 << CS00));
   OCR0A = 255;
   OCR0B = 255;
   TCCR1A = 0x00;
   TCCR1B = 0x00;
   TCCR1C = 0x00;
   TIMSK |= (1 << TOIE1);
   MCUCR |= ((0 << ISC11)|(1 << ISC10));
   GIMSK |= (1 << INT1);
   sei();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main()
{
   reg_config();
   
   while(1)
   {
    
   if (BitIsClear(JP_PIN, JP_IN))
   {
      non_revers = 1;
   }
      if (non_revers == 0)
      {
	 if (counter == 0){
	    OCR0A = 255;
	    OCR0B = 255;
	 }
	 else if (counter < 1500){
	    OCR0B = 255;
	    OCR0A = (counter - 1000)/2;
	 }
	 else{
	    OCR0A = 255;
	    OCR0B = 255 - (counter - 1500)/2;
	 }
      }
      else{
	 OCR0B = 255;
	 OCR0A = 255 - (counter - 1000)/4;
      }
   }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ISR(INT1_vect)
{
   if (BitIsSet(PWM_PIN, PWM_IN)){
      TCNT1 = 0;
      TCCR1B |= (1 << CS11);
   }
   else{
      TCCR1B = 0x00;
      counter = TCNT1;
      
      if (counter < 1000)
      {
	 counter = 1000;
      }
      else if (counter > 2000)
      {
	 counter = 2000;
      }
   }
}


ISR(SIG_OVERFLOW1)
{
   TCCR1B &= ~(1 << CS11);
   TCNT1 = 0;
}